/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                Chapter 19
       Code written by: Morteza Naghmekou
*/

#include<fstream>
#include <iostream>
using namespace std;

class sudoku
{
public:
  int i,j,k,***p,**a,**N;
  sudoku()
  {
    a=new int*[9];
    N=new int*[9];
    p=new int**[9];
    for(i=0;i<9;i++)
    {
      a[i]=new int[9];
      N[i]=new int[9];
      p[i]=new int*[9];
      for(j=0;j<9;j++)
        p[i][j]=new int[9];
    }
  }
  int check1(int i, int j)
  {
    if(a[i][j]<0 || a[i][j]>9)
    {
      cout<<"Your number must be between 0 to 9,Please correct Row "<<i+1<<",column "<<j+1<<" :";
      cin>>a[i][j];
      return a[i][j];
    }
  }
  void conditions(int***r, int***c)
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        N[i][j]=0;
        if(a[i][j]==0)
        {
          for(k=0;k<9;k++)
          {
            if(p[k][i][j]==r[k][i][j] && p[k][i][j]==c[k][i][j] && p[k][i][j]!=0)
              N[i][j]++;
            else
              p[k][i][j]=0;
          }
          for(k=0;k<9;k++)
          {
            if(N[i][j]==1 && p[k][i][j]!=0)
              a[i][j]=p[k][i][j];
          }
        }
      }
    }
  }
  int** operator *(sudoku u)
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        u.a[i][j]=a[i][j];
      }
    }
    return u.a;
  }
};

class row:public sudoku
{
public:
  int m,**r;
  row(){}
  row(sudoku u)
  {
    r=new int*[9];
    for(i=0;i<9;i++)
    {
      r[i]=new int[9];
      for(j=0;j<9;j++)
      {
        r[i][j]=u.a[i][j];
        if(r[i][j]==0)
        {
          for(k=0;k<9;k++)
            p[k][i][j]=k+1;
        }
        else
        {
          for(k=0;k<9;k++)
            p[k][i][j]=0;
        }
      }
    }
  }

  void check2()
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<9;k++)
        {
          if(j!=k && r[i][j]==r[i][k] && r[i][j]!=0)
          {
            cout<<"Error in Row "<<i+1<<" and columns "<<j+1<<" and "<<k+1;
            cout<<"\nColumn "<<j+1<<" :";
            cin>>r[i][j];
            cout<<"Column "<<k+1<<" :";
            cin>>r[i][k];
          }
        }
      }
    }
  }

  void check3()
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<9;k++)
        {
          if(r[i][j]==0 && r[i][k]!=0)
          {
            int M=r[i][k]-1;
            p[M][i][j]=0;
          }
          if(r[i][j]!=0)
          {
            for(m=0;m<9;m++)
              p[m][i][j]=0;
          }
        }
      }
    }
  }

  int** operator +=(sudoku u)
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        u.a[i][j]=r[i][j];
      }
    }
    return u.a;
  }

  void check4(int**D,int a)
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<a;k++)
        {
          if(D[k][0]==i && D[k][1]==j)
          {
            for(m=0;m<9;m++)
            {
              if(j!=m && r[i][j]==r[i][m] && r[i][j]!=0)
                r[i][j]=0;
            }
          }
        }
      }
    }
  }
};

class col:public sudoku
{
public:
  int m,**c;
  col(){}

  col(sudoku u)
  {
    c=new int*[9];
    for(i=0;i<9;i++)
    {
      c[i]=new int[9];
      for(j=0;j<9;j++)
      {
        c[i][j]=u.a[j][i];
        if(c[i][j]==0)
        {
          for(k=0;k<9;k++)
            p[k][i][j]=k+1;
        }
        if(c[i][j]!=0)
        {
          for(k=0;k<9;k++)
            p[k][i][j]=0;
        }

      }
    }
  }

  void check2()
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<9;k++)
        {
          if(j!=k && c[i][j]==c[i][k] && c[i][j]!=0)
          {
            cout<<"Error in Column "<<i+1<<" and Rows "<<j+1<<" and "<<k+1;
            cout<<"\nRow "<<j+1<<" :";
            cin>>c[i][j];
            cout<<"Row "<<k+1<<" :";
            cin>>c[i][k];
          }
        }
      }
    }                
  }

  void check3()
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<9;k++)
        {

          if(c[i][j]==0 && c[i][k]!=0)
          {
            int M=c[i][k]-1;
            p[M][i][j]=0;
          }
          if(c[i][j]!=0)
          {
            for(m=0;m<9;m++)
              p[m][i][j]=0;
          }
        }
      }
    }
  }

  int** operator +=(sudoku u)
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
        u.a[i][j]=c[j][i];
    }
    return u.a;
  }

  void check4(int**D,int a)
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<a;k++)
        {
          if(D[k][0]==j && D[k][1]==i)
          {
            for(m=0;m<9;m++)
            {
              if(j!=m && c[i][j]==c[i][m] && c[i][j]!=0)
                c[i][j]=0;
            }
          }
        }
      }
    }
  }
};

class squ:public sudoku
{
public:
  int m,l,o,**s;
  squ(){}
  squ(sudoku u)
  {
    s=new int*[9];
    for(i=0;i<9;i++)
      s[i]=new int[9];
    i=0;
    while(i<9)
    {
      for(j=0;j<9;j=j+3)
      {
        m=0;
        for(k=3*(i/3);k<3*(i/3)+3;k++)
        {
          for(l=j;l<j+3;l++)
          {
            s[i][m]=u.a[k][l];
            if(s[i][m]==0)
            {
              for(o=0;o<9;o++)
                p[o][i][m]=o+1;
            }
            else
            {
              for(o=0;o<9;o++)
                p[o][i][m]=0;
            }
            m++;     
          }
        }
        i++;
      }
    }
  }

  void check2()
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<9;k++)
        {
          if(j!=k && s[i][j]==s[i][k] && s[i][j]!=0)
          {
            cout<<"Error in Square "<<i+1<<" and places "<<j+1<<" and "<<k+1;
            cout<<"\nplace "<<j+1<<" :";
            cin>>s[i][j];
            cout<<"place "<<k+1<<" :";
            cin>>s[i][k];
          }
        }
      }
    }
  }

  int*** check3(sudoku u)
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<9;k++)
        {
          if(s[i][j]==0 && s[i][k]!=0)
          {
            int M=s[i][k]-1;
            p[M][i][j]=0;                                                                     
          }
        }
      }
    }
    i=0;
    while(i<9)
    {
      for(j=0;j<9;j=j+3)
      {
        m=0;
        for(k=3*(i/3);k<3*(i/3)+3;k++)
        {
          for(l=j;l<j+3;l++)
          {
            for(o=0;o<9;o++)
              u.p[o][k][l]=p[o][i][m];
            m++;     
          }
        }
        i++;
      }
    }
    return u.p;
  }

  int** operator +=(sudoku u)
  {
    i=0;
    while(i<9)
    {
      for(j=0;j<9;j=j+3)
      {
        m=0;
        for(k=3*(i/3);k<3*(i/3)+3;k++)
        {
          for(l=j;l<j+3;l++)
          {
            u.a[k][l]=s[i][m];
            m++;     
          }
        }
        i++;
      }
    }
    return u.a;
  }

  void check4()
  {
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<9;k++)
        {
          if(j!=k && s[i][j]==s[i][k] && s[i][j]!=0)
            s[i][j]=0;
        }
      }
    }             
  }
};       


int main()
{
  cout<<"  |---------------------------------------|\n";
  cout<<"           SUDOKU SOLVER PROGRAM           \n";
  cout<<"  |---------------------------------------|\n";
  //cout<<endl<<"Please enter your numbers by row order and put space between your numbers\n\nFor empty squares enter '0'\n\n";
  int i,j,k,m,n,l,a,b,o;
  int***r,***c;
  sudoku A;
  ifstream fin;
  fin.open("e.txt");
  r=new int**[9];
  c=new int**[9];
  for(i=0;i<9;i++)
  {
    r[i]=new int*[9];
    c[i]=new int*[9];
    //cout<<"Please insert row "<<i+1<<" :";
    for(j=0;j<9;j++)
    {
      r[i][j]=new int[9];
      c[i][j]=new int[9];
      //cin>>A.a[i][j];
      fin>>A.a[i][j];
    }
    for(j=0;j<9;j++)
    {
      while(A.a[i][j]<0 || A.a[i][j]>9)
        A.a[i][j]=A.check1(i,j);
    }
  }
  fin.close();
  cout<<endl<<"The sudoku that you entered was: "<<endl;;
  for(i=0;i<9;i++)
  {
    for(j=0;j<9;j++)
    {
      cout<<A.a[i][j]<<" ";
    }
    cout<<endl;
  }
  cout<<endl;
  row*R;
  col*C;
  squ*S;
  R=new row(A);
  R->check2();
  A.a=*R+=A;
  C=new col(A);
  C->check2();
  A.a=*C+=A;
  S=new squ(A);
  S->check2();
  A.a=*S+=A;
  delete R,C,S;
  for(a=0;a<81;a++)
  {
    R=new row(A);
    C=new col(A);
    S=new squ(A);
    R->check3();
    C->check3();
    A.p=S->check3(A);
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        for(k=0;k<9;k++)
        {
          r[k][i][j]=R->p[k][i][j];
          c[k][i][j]=C->p[k][j][i];
        }
      }
    }
    A.conditions(r,c);
    delete R,C,S;
  }
  a=0;
  for(i=0;i<9;i++)
  {
    for(j=0;j<9;j++)
    {
      if(A.a[i][j]==0)
        a++;                                                 
    }
  }
  if(a==0)
  {
    cout<<"the solved sudoko is:"<<endl<<endl;
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        cout<<A.a[i][j]<<" ";
        if((j+1)%3==0)cout<<"  ";
      }
      cout<<endl;
      if((i+1)%3==0)cout<<endl;
    }
  }
  else
  {
    int**I,*B,**D,*P,*F;
    double*sum;
    cout<<"Please wait...."<<endl<<endl;
    I=new int*[a];
    B=new int[a];
    D=new int*[a];
    sum=new double[a+1];
    for(i=0;i<a;i++)
      D[i]=new int[2];
    m=0;
    b=0;
    for(i=0;i<9;i++)
    {
      for(j=0;j<9;j++)
      {
        if(A.a[i][j]==0)
        {
          for(k=0;k<9;k++)
          {
            if(A.p[k][i][j]!=0)
              b++;
          }
          I[m]=new int[b];
          B[m]=b;
          D[m][0]=i;
          D[m][1]=j;
          o=0;
          for(k=0;k<9;k++)
          {
            if(A.p[k][i][j]!=0)
            {
              I[m][o]=A.p[k][i][j];
              o++;
            }
          }
          m++;
          b=0;
        }
      }
    }
    F=new int[a];
    for(i=0;i<a;i++)
      F[i]=0;
    sum[0]=1;
    for(i=1;i<=a;i++)
      sum[i]=sum[i-1]*B[i-1];
    P=new int[a];
    n=0;
    int Q,q;
    for(m=0;m<sum[a];m++)
    {
      for(i=0;i<a;i++)
      {
        b=(int)sum[i+1];
        b=m%b;
        q=(int)sum[i];
        F[i]=(b/q);
        Q=0;
        P[i]=I[i][F[i]];
      }
      for(i=0;i<a;i++)
      {
        for(j=i;j>=0;j--)
        {
          if(F[j]<((sum[j+1]/sum[j])))
            Q=1;
        }
        switch(Q)
        {
        case(1):
          break;
        case(0):
          {
            for(j=i;j>=0;j--)
            {
              F[j]=0;
            }

            F[j+1]++;
            break;
          } 
        }

      }
      sudoku*SU;
      SU=new sudoku;
      SU->a=A*(*SU);
      for(l=0;l<a;l++)
        SU->a[D[l][0]][D[l][1]]=P[l];
      R=new row(*SU);
      R->check4(D,a);
      SU->a=*R+=*SU;
      C=new col(*SU);
      C->check4(D,a);
      SU->a=*C+=*SU;
      S=new squ(*SU);
      S->check4();
      SU->a=*S+=*SU;
      delete R,C,S;
      for(i=0;i<9;i++)
      {
        for(j=0;j<9;j++)
        {
          if(SU->a[i][j]==0)
            l=0;
        }
      }
      if(l!=0)
      {
        for(i=0;i<9;i++)
        {
          for(j=0;j<9;j++)
          {
            cout<<SU->a[i][j]<<" ";
            if((j+1)%3==0)cout<<"  ";
          }
          cout<<endl;
          if((i+1)%3==0)cout<<endl;
        }
        cout<<endl<<endl;
        n++;
      }
      delete SU,P;
    }
    cout<<"The sudoku that you entered have "<<n<<" solution(s)";
  }

  cin>>i;
  return 0;
}
